<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;
use TelegramNotifications\Messages\TelegramMessage;
use TelegramNotifications\TelegramChannel;

class TelegramNotification extends Notification
{
    use Queueable;

    private $mensagem;
    const BOAS_VINDAS = 'boasVindas';
    const NOVA_SOLICITACAO_CADASTRADOR = 'novaSolicitacaoCadastrador';
    const NOVA_SOLICITACAO_FUNCIONARIO = 'novaSolicitacaoFuncionario';
    const SOLICITACAO_RESPONDIDA = 'solicitacaoRespondida';

    /**
     * Create a new notification instance.
     *
     * @return void
     */
    public function __construct($mensagem)
    {
        $this->mensagem = $mensagem;
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function via()
    {
        return [TelegramChannel::class];
    }

    public function toTelegram()
    {
        return $this->selecionaMensagem($this->mensagem);
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
            ->line('The introduction to the notification.')
            ->action('Notification Action', url('/'))
            ->line('Thank you for using our application!');
    }

    /**
     * Get the array representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function toArray($notifiable)
    {
        return [
            //
        ];
    }

    public function selecionaMensagem($mensagem)
    {
        switch ($mensagem) {
            case 'boasVindas':
                return $this->boasVindas();
                break;

            case 'novaSolicitacaoCadastrador':
                return $this->novaSolicitacaoCadastrador();
                break;

            case 'novaSolicitacaoFuncionario':
                return $this->novaSolicitacaoFuncionario();
                break;

            case 'solicitacaoRespondida':
                return $this->solicitacaoRespondida();
                break;

            default:
                //code...
                break;
        }
    }

    public function boasVindas()
    {
        return (new TelegramMessage(['parse_mode' => 'HTML']))
            ->parse_mode('HTML')
            ->text('<b>Bem-vindo(a) a Ouvidoria Municipal de Olinda!</b>'
                . ' Tire dúvidas, denuncie, elogie e faça sugestões à administração da cidade.'
                . ' Aqui a sua voz tem vez!'
                . ' Esta mensagem foi gerada automaticamente. Favor não responder.');
    }

    public function novaSolicitacaoCadastrador()
    {
        return (new TelegramMessage(['parse_mode' => 'HTML']))
            ->parse_mode('HTML')
            ->text('Olá. Você está recebendo esta mensagem automática pois uma nova solicitação foi postada. '
                . ' '
                //O link não funcionará com "localhost"! Deve-se colocar um IP em APP_URL, pelo menos.
                . '<a href="' . url('/') . '">Clique Aqui para ver.</a>');
    }

    public function novaSolicitacaoFuncionario()
    {
        return (new TelegramMessage(['parse_mode' => 'HTML']))
            ->parse_mode('HTML')
            ->text('Olá. Uma nova solicitação foi atribuída para a sua Secretaria.'
                . ' '
                //O link não funcionará com "localhost"! Deve-se colocar um IP em APP_URL, pelo menos.
                . '<a href="' . url('/') . '">Confira aqui!</a>');
    }

    public function solicitacaoRespondida()
    {
        return (new TelegramMessage(['parse_mode' => 'HTML']))
            ->parse_mode('HTML')
            ->text('Sua solicitação foi respondida!'
                . ' '
                //O link não funcionará com "localhost"! Deve-se colocar um IP em APP_URL, pelo menos.
                . '<a href="' . url('/') . '">Confira aqui!</a>');
    }
}
